unit process_killer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TLHelp32, StdCtrls, ComCtrls, XPMan, Buttons, ExtCtrls, ImgList,
  TrayIcon, AutoRun ;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    XPManifest1: TXPManifest;
    Panel1: TPanel;
    Button1: TButton;
    BitBtn1: TBitBtn;
    Button2: TButton;
    Label1: TLabel;
    ImageList1: TImageList;
    TrayIcon: TTrayIcon;
    Button3: TButton;
    Label2: TLabel;
    Panel2: TPanel;
    Edit1: TEdit;
    Button4: TButton;
    AutoRun1: TAutoRun;
    Panel3: TPanel;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { }
  procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  aSnapshotHandle: THandle;
  aProcessEntry32: TProcessEntry32;
const
  MyHotKey = ord(vk_F10);


implementation

{$R *.dfm}

procedure TForm1.WMHotKey(var Msg: TWMHotKey);
begin
with Form1.TrayIcon do begin
FormVisible:=not visible;
Button1.Click;
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   i: Integer;
   bContinue: BOOL;
   NewItem: TListItem;
 begin
   ListView1.Items.Clear;
   aSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
   aProcessEntry32.dwSize := SizeOf(aProcessEntry32);
   bContinue := Process32First(aSnapshotHandle, aProcessEntry32);
   while Integer(bContinue) <> 0 do
   begin
     NewItem := ListView1.Items.Add;
     NewItem.Caption := ExtractFileName(aProcessEntry32.szExeFile);
     NewItem.subItems.Add(IntToHex(aProcessEntry32.th32ProcessID, 4));
     NewItem.subItems.Add(aProcessEntry32.szExeFile);
     bContinue := Process32Next(aSnapshotHandle, aProcessEntry32);
   end;
   CloseHandle(aSnapshotHandle);

end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
   Ret: BOOL;
   PrID: Integer; // processidentifier 
  Ph: THandle;   // processhandle 
begin
   with ListView1 do
   begin
     if MessageDlg('Do you want to Terminate "' + ItemFocused.Caption + '"?' + ^J +
                   'It''s possible the system becames instable or out of' + ^J +
                   'control......',
         mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
        PrID := StrToInt('$' + ItemFocused.SubItems[0]);
        Ph := OpenProcess(1, BOOL(0), PrID);
        Ret := TerminateProcess(Ph, 0);
        if Integer(Ret) = 0 then
          MessageDlg('Cannot terminate "' + ItemFocused.Caption + '"',
                      mtInformation, [mbOK], 0)
        else
          ItemFocused.Delete;
      end;
    end;

end;



procedure TForm1.ListView1DblClick(Sender: TObject);
var
   Ret: BOOL;
   PrID: Integer; // processidentifier 
  Ph: THandle;   // processhandle 
begin
   with ListView1 do
      begin
        PrID := StrToInt('$' + ItemFocused.SubItems[0]);
        Ph := OpenProcess(1, BOOL(0), PrID);
        Ret := TerminateProcess(Ph, 0);
        if Integer(Ret) = 0 then
          MessageDlg('Cannot terminate "' + ItemFocused.Caption + '"',
                      mtInformation, [mbOK], 0)
        else
          ItemFocused.Delete;
      end;


end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
resp:word;
begin
 MessageBeep(MB_ICONASTERISK);
resp:=MessageDlg('Terminate work?', mtInformation,[mbYes,mbNo],0);
 if resp = mrYes
  then
Form1.Close
else
 exit;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
MessageBox(0, 'Process Killer v1.1'+#13+'copyright(c)2007. onyx'+#13+'http://www.onyx.uzelok.net/'+#13+'mailto:onyxe@mail.ru','About', MB_OK+MB_ICONInformation);
end;

procedure TForm1.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
if Item.Index mod 2=0
 then
  begin
   Sender.Canvas.Font.Color:=clBlack;
   Sender.Canvas.Brush.Color:=$00E4E4E4;
    if cdsSelected in State then
    Sender.Canvas.Font.Style := Sender.Canvas.Font.Style + [fsbold];
    Sender.Canvas.Font.color := Sender.Canvas.Font.color + $00804000;
  end
 else
  begin
   Sender.Canvas.Font.Color:=clBlack;
   Sender.Canvas.Brush.Color:=clWhite;
    if cdsSelected in State then
    Sender.Canvas.Font.Style := Sender.Canvas.Font.Style + [fsbold];

  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
Button1.Click;
RegisterHotKey(Form1.Handle, MyHotKey, 0, MyHotKey);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
UnRegisterHotKey(Form1.Handle, MyHotKey);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Form1.TrayIcon.FormVisible:=false;
end;

function FindListViewItem(lv: TListView; const S: string; column: Integer): TListItem;
var
  i: Integer;
  found: Boolean;
begin
  Assert(Assigned(lv));
  Assert((lv.viewstyle = vsReport) or (column = 0));
  Assert(S <> '');
  for i := 0 to lv.Items.Count - 1 do
  begin
    Result := lv.Items[i];
    if column = 0 then
      found := AnsiCompareText(Result.Caption, S) = 0 
    else if column > 0 then
      found := AnsiCompareText(Result.subItems[column - 0], S) = 0
    else
      found := False;
    if found then
      Exit;
  end;
  // No hit if we get here 
  Result := nil;
end;


function FindCaption(StartIndex: Integer; Value: string; Partial, Inclusive, Wrap: Boolean): TListItem;
 begin
 end;



procedure TForm1.Button4Click(Sender: TObject);
var 
  lvItem: TListItem;
begin
  lvItem := ListView1.FindCaption(0,      // StartIndex: Integer;
                                  Edit1.Text,   // Search string: string;
                                  True,   // Partial,
                                  True,   // Inclusive
                                  False); // Wrap  : boolean;
  if lvItem <> nil then
  begin
    ListView1.Selected := lvItem;
    lvItem.MakeVisible(True);
    ListView1.SetFocus;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.Checked=true
then
Form1.FormStyle:=fsStayOnTop
else
Form1.FormStyle:=fsNormal

end;

end.
